﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ProjektSWB
{
    public partial class Form1 : Form
    {
        bool _isRunning = false;
        Graphics g = null;
        float skala_x = 10, skala_y = 10;
        Point obserwator;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (_isRunning)
            {
                button1.Text = "Start";
                _isRunning = false;

                serialPort1.Close();

                listBox1.Items.Add("Stopped!");
            }

            g.Clear(Color.Black);
            g.DrawRectangle(new Pen(Color.Fuchsia), new Rectangle(obserwator, new Size(10, 10)));
            pictureBox1.Invalidate();

            var port = textBox1.Text;

            if (port.Length == 0)
            {
                MessageBox.Show("Podaj numer portu!");
                return;
            }

            port = "COM" + port;

            serialPort1.PortName = port;

            try
            {
                serialPort1.Open();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                return;
            }

            _isRunning = true;

            button1.Text = "Stop";

            listBox1.Items.Add("Started listening on port " + port);
        }

        void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            var line = serialPort1.ReadLine();

            listBox1.Items.Add(line);

            var items = line.Split(';');

            var kat = float.Parse(items[0]);
            var odleglosc = float.Parse(items[1]);

            drawPoint(kat, odleglosc);
        }

        private Point getCord(float angle, float dist)
        {
            float x = (float)Math.Cos(angle) * dist * skala_x;
            float y = (float)Math.Sin(angle) * dist * skala_y;

            return new Point((int)x, (int)y);
        }

        private void drawPoint(float kat, float odleglosc)
        {
            Point odczyt = getCord(kat, odleglosc);
            Point punkt = new Point(obserwator.X - odczyt.X, obserwator.Y - obserwator.Y);
            g.DrawRectangle(new Pen(Color.Gold), new Rectangle(punkt, new Size(10, 10)));
            pictureBox1.Invalidate();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            serialPort1.DataReceived += new System.IO.Ports.SerialDataReceivedEventHandler(serialPort1_DataReceived);
            g = pictureBox1.CreateGraphics();
            obserwator = new Point(pictureBox1.Width / 2, pictureBox1.Height / 2);
        }
    }
}
